/*
license GPL
author danim1987@gmail.com
*/

#ifndef AURP_HEADER_H
#define AURP_HEADER_H

#include "ns3/header.h"
#include "ns3/uan-address.h"

namespace ns3 {


class AURPHeader : public Header
{

public:

 	AURPHeader ();
 	AURPHeader (uint16_t jum, uint16_t orig,uint16_t destino, uint16_t packetNumber, bool phe, bool da, bool au);
  	virtual ~AURPHeader ();

  	static TypeId GetTypeId (void);
	void SetJumps(float depth) {jumps = depth;}
	float GetJumps() {return jumps;}
	
	void SetOrig(uint16_t u) {m_id = u;}
	uint16_t GetOrig() {return m_id;}
	
	void SetDes(uint16_t u) {destino_id = u;}
	uint16_t GetDes() {return destino_id;}
	
	void SetPacketNumber(uint16_t n) {m_packetNumber = n;}
	uint16_t GetPacketNumber() {return m_packetNumber;}

//AUV
	bool GetPHE(){return PHE;}
	void SetPHE(bool P){ PHE=P;}

	bool GetData(){return Data;}
	void SetData(bool D){Data=D;}

	bool GetAuv(){return auv;}
	void SetAuv(bool A){auv=A;}
	

 	// Inherrited methods
	uint32_t GetSerializedSize (void) const;
	void Serialize (Buffer::Iterator start) const;
	uint32_t Deserialize (Buffer::Iterator start);
	void Print (std::ostream &os) const;
	virtual TypeId GetInstanceTypeId (void) const;	

private:

	uint16_t jumps;	//saltos realizados para PHE
	uint16_t m_id;
	uint16_t destino_id;
	uint16_t m_packetNumber;
//Tipo de paquete
	bool PHE; 
	bool Data;
	bool auv;

}; //class AURP-Header


class AURPHeaderAUV : public Header
{

public:

 	AURPHeaderAUV ();
 	//AURPHeader (uint16_t jum, uint16_t orig,uint16_t destino, uint16_t packetNumber, bool phe, bool da, bool au);
  	virtual ~AURPHeaderAUV ();

  	static TypeId GetTypeId (void);
	
	void SetOrig(uint16_t u) {m_id = u;}
	uint16_t GetOrig() {return m_id;}
	
	void SetDes(uint16_t u) {destino_id = u;}
	uint16_t GetDes() {return destino_id;}
	
	void SetMin(uint16_t u) {min = u;}
	uint16_t GetMin() {return min;}
	
	void SetMax(uint16_t u) {max = u;}
	uint16_t GetMax() {return max;}
	
	void SetPacketNumber(uint16_t n) {m_packetNumber = n;}
	uint16_t GetPacketNumber() {return m_packetNumber;}

	
	bool GetPeticion(){return peticion;}
	void SetPeticion(bool P){ peticion=P;}
	
	bool GetSink(){return sink;}
	void SetSink(bool D){sink=D;}

	bool GetAck(){return ack;}
	void SetAck(bool D){ack=D;}


 	// Inherrited methods
	uint32_t GetSerializedSize (void) const;
	void Serialize (Buffer::Iterator start) const;
	uint32_t Deserialize (Buffer::Iterator start);
	void Print (std::ostream &os) const;
	virtual TypeId GetInstanceTypeId (void) const;	

private:

	uint16_t m_id;
	uint16_t destino_id;
	uint16_t min;
	uint16_t max;
	uint16_t m_packetNumber;
//Tipo de paquete
	bool peticion; 
	bool sink;
	bool ack;

}; //class AURP-Header

} //namespace ns3

#endif //AURP_HEADER_H

