/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2010 Andrea Sacco
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author: Andrea Sacco <andrea.sacco85@gmail.com>
 */

///////////EXPLICACIÓN DE LA FALLA
/* La main está al final del programa el cual llama a Run y se desentiende




*/

#include "ns3/uan-net-device.h"
#include "ns3/simulator.h"
#include "ns3/packet.h"
#include "ns3/node.h"
#include "ns3/auv-glider-helper.h"
#include "ns3/waypoint-mobility-model.h"
#include "ns3/uan-helper.h"
#include "ns3/basic-energy-source-helper.h"
#include "ns3/acoustic-modem-energy-model-helper.h"
#include "ns3/constant-position-mobility-model.h"
#include "ns3/log.h"
#include "ns3/uan-channel.h"
#include "ns3/uan-noise-model-default.h"
#include "ns3/uan-prop-model-ideal.h"
#include "uan-energy-auv.h"

#include<fstream>
#include "ns3/gnuplot.h"
#include "ns3/uan-module.h"
#include <iostream>
#include <sstream>
#include <stdio.h>  
#include <math.h>  



#include <limits>
#include <set>

#include "ns3/AURP-header.h"
#include "ns3/AURP-node.h"

#include "ns3/random-variable.h"

#include "ns3/mobility-module.h"


#include "ns3/core-module.h"
#include "ns3/point-to-point-net-device.h"
#include "ns3/point-to-point-helper.h"
#include "ns3/data-rate.h"



using namespace ns3;
  std::ofstream file_pos_nodos;
  std::ofstream file_mov_auv;

//variables globales 
double tiempo=1500;
int nu_sink = 1;    //numero de sumideros, auv, GW, sensores.
int nu_auv= 0;
int nu_gata = 1;
int nu_sensor =4;
int x,y;

//Tiempos de espera para reenviar mensajes repetitivos 
int time_AUV=400;
int time_PHE_GW=300,time_PHE_sink=300 ;
int time_data=100;
int Time_PHE_procesar=150;

//Ptr<UniformVariable> random;
int random_wait_inicio_envios= 50;


//variables de GW
double ang_gw = 0, incremento_ang_gw = (2*M_PI)/nu_gata;
long m_sentPackets_GW = 0,m_sentPackets_sink=0;
long m_sentPackets_PHE=0, m_sentPackets_data=0;
long m_send_submarine=0,m_bytesRx_submarine=0;

//Variables relacionadas con la posición
double x_sink=0, y_sink=0;
double X_central1=-400,   X_central2=0,   X_central3=0,   X_central4=0;
double Y_central1=00,   Y_central2=0,   Y_central3=0,   Y_central4=0;
int x_map= 2500, y_map= 2500;

//variables relacionadas con la aproximación
TypeId  tid;
uint32_t  tid_ut;

//trazas
std::ofstream envios_sink; 
std::ofstream envios_auv;
std::ofstream envios_GW; 
std::ofstream envios_sensor; 

std::string nom_envios_sink = "auv/envios_sink.txt";
std::string nom_envios_auv = "auv/envios_AUV.txt";
std::string nom_envios_GW = "auv/envios_GW.txt";
std::string nom_envios_sensor = "auv/envios_sensor.txt";
std::string nom_pos_nodos = "auv/Posicion_nodos.txt";
std::string nom_pos_auv = "auv/movimiento_auv.txt";

std::string m_traceFile = "auv/devices";

//containers
NodeContainer nc_sink= NodeContainer ();
NodeContainer nc_AUV= NodeContainer ();
NodeContainer nc_GW= NodeContainer ();
NodeContainer nc_sensors= NodeContainer ();

///obtencion le la elipse
  //valores predefinidos
double A=400, B=200;               //<---       //tamaño elipse
//double frecuencia =5.421586794, velocidad =1;
double frecuencia =0.19, velocidad =1;
double distancia_referencia;
int vueltas =1;

double angu_elipse1= 1, angu_elipse2= 0, angu_elipse3= 0, angu_elipse4= 0, angulo=0;            //radianes

//double X_central=-400 , Y_central=-200;
//double x_inicio=

//variables de almacanamiento
double distancia;
double dif_x, dif_y;
double x_aux,y_aux, x_eli, y_eli, ansx, ansy;

double X_GW1=00,X_GW2=400,X_GW3=0,X_GW4=0,X_GW5=0,X_GW6=0,X_GW7=0,X_GW8=0,X_GW9=0;
double Y_GW1=0,Y_GW2=0,Y_GW3=0,Y_GW4=0,Y_GW5=0,Y_GW6=0,Y_GW7=0,Y_GW8=0,Y_GW9=0;


//Recopilación de datos sobre los mesajes de datos
int m_creados_total=0,energia_consumida_total=0, M_recividos=0, m_recividos_auv=0,m_recividos_gw=0;

//numero de nodos sin GW
int no_GW=0;

//Energuia de trasmision de los nodos
int power_py=585;

//Ancho de banda 
uint32_t datarate = 140000;
uint32_t datarate_sensores = 14000;

UanEnergyAuv::UanEnergyAuv ()
  : m_bytesRx (0),
    //m_recibed(0),
    m_sentPackets (0)
{
}

UanEnergyAuv::~UanEnergyAuv ()
{
  m_auv = 0;
  //m_recibed = 0;
  m_sink=0;
  m_AUV=0;
  m_gateway = 0;
  m_sensor=0;
  
}

//Prueva de envio de los 3 mensajes del submarino.
void
UanEnergyAuv::Send_submarino (Ptr<Node> node)
{

  //node->GetObject<AURPNode>()->Send_Solicitud(node);
  //node->GetObject<AURPNode>()->Send_Solicitud_enviar(node);
  //node->GetObject<AURPNode>()->Send_Ack(node);
  
  // increase the sent packets number
  ++m_send_submarine;
  
  
  //bucle de envio
  Simulator::Schedule (Seconds (100+3*node->GetObject<AURPNode>()->GetID()),
                       &UanEnergyAuv::Send_submarino,
                       this,
                       node);
}

//Envio de mensaje AUV de proximidad
void
UanEnergyAuv:: Send_AUV_prox (Ptr<Node> node)
{
  
  node->GetObject<AURPNode>()-> Send_AUV_prox(node);
  // increase the sent packets number
  ++m_sentPackets;

  Simulator::Schedule (Seconds (time_AUV),
                       &UanEnergyAuv::Send_AUV_prox,
                       this,
                       node);
}

//envio mensaje PHE
void
UanEnergyAuv::Send_PHE (Ptr<Node> node, int time)
{

  node->GetObject<AURPNode>()->Send_PHE(node);
  // increase the sent packets number
  ++m_sentPackets_PHE;
  
  
  //bucle de envio
  /*Simulator::Schedule (Seconds (100+3*node->GetObject<AURPNode>()->GetID()),
                       &UanEnergyAuv::Send_PHE,
                       this,
                       node);*/


  //bucle de envio
  Simulator::Schedule (Seconds (time),
                       &UanEnergyAuv::Send_PHE,
                       this,
                       node, time);
}


//Envio mensaje Data
void
UanEnergyAuv::Send_Data (Ptr<Node> node)
{
  //int ti=node->GetObject<AURPNode>()->GetID()*10;
  //wait(10);
  node->GetObject<AURPNode>()->Gestor_Data(node, 800, time_data);
  // increase the sent packets number
  ++m_sentPackets_data;
  
  
  //bucle de envio
  /*Simulator::Schedule (Seconds (30+node->GetObject<AURPNode>()->GetID()*10),
                       &UanEnergyAuv::Send_Data,
                       this,
                       node);*/
                       
    //bucle de envio
  /*Simulator::Schedule (Seconds (time_data),
                       &UanEnergyAuv::Send_Data,
                       this,
                       node);*/
}

//crear packetes de datos
void
UanEnergyAuv::Crear_data (Ptr<Node> node)
{

  node->GetObject<AURPNode>()->Create_Data_Pack(node, 20);
  // increase the sent packets number
  //++m_sentPackets_PHE;
  
  
  //bucle de envio
  /*Simulator::Schedule (Seconds (100+3*node->GetObject<AURPNode>()->GetID()),
                       &UanEnergyAuv::Send_PHE,
                       this,
                       node);*/


  //bucle de envio
  Simulator::Schedule (Seconds (30),
                       &UanEnergyAuv::Crear_data,
                       this,
                       node);
}

//Receptor de los mensajes, Los clasifica  los envia al receptor correspondiente
bool
UanEnergyAuv::RxPacket (Ptr<NetDevice> dev, Ptr<const Packet> pkt, uint16_t mode, const Address &sender)
{
  ++m_bytesRx;
  Ptr<Node> node= dev->GetNode();
  Ptr<AURPNode> foo= node->GetObject<AURPNode> ();
  switch (foo->GetTipe()){
    case 1:
      return foo->ReceiveSink(pkt, node);
      break;
    case 2:
      return foo->ReceiveAUV(pkt,node);
    case 3:
      return foo->ReceiveGW(pkt,node);
      break;
    case 4:
      return foo->ReceiveSensor(pkt,node);
      break;
    default: 
       std::cout << "MENSAJE PA NADIE " << std::endl;
      return false; 
  }
  return false;
}

//Receptor de mensajes del submarino
bool
UanEnergyAuv::RxPacket_submarino (Ptr<NetDevice> dev, Ptr<const Packet> pkt, uint16_t mode, const Address &sender)
{
  ++m_bytesRx_submarine;
  Ptr<Node> node= dev->GetNode();
  Ptr<AURPNode> foo= node->GetObject<AURPNode> ();
  switch (foo->GetTipe()){
    case 1:
      return foo->ReceiveSink_submarino(pkt, node);
      break;
    case 2:
      return foo->ReceiveAUV_submarino(pkt, node);
      break;
    case 3:
      return foo->ReceiveGW_submarino(pkt,node);
      break;
    case 4:
     // return foo->ReceiveSensor_submarino(pkt,node);
        std::cout << "MENSAJE PA Sensor " << std::endl;
      break;
    default: 
       std::cout << "MENSAJE PA NADIE " << std::endl;
      return false; 
  }
  return false;
}

void
UanEnergyAuv::PrintStats ( NodeContainer nc1)
{
  Ptr<AURPNode> print;
  //double inicio, fin;
  std::cout << "Total sent data: " << m_sentPackets_data << " and recibidos " << m_bytesRx << std::endl;
  std::cout << "Total sent submarino ciclos: " << m_send_submarine << " and recibidos " << m_bytesRx_submarine << std::endl;
  std::cout << "tiempo simulacion " <<Simulator::Now()<< " numero de nodos "<<nc1.GetN()<<std::endl;
  for(uint32_t i=0;i<nc1.GetN();i++){
    print=nc1.Get(i)->GetObject<AURPNode> ();
    std::cout << "Nodo con id: "<< print->GetID() <<" mensajes recibidos: "<< print->GetMrec() << std::endl;
    std::cout << "Received PHE: " << print->GetMrPHE() <<" send PHE: " << print->GetMsPHE()<< " mensajes"<< std::endl;
    std::cout << "Received data: " << print->GetMrdata() <<" send data: " << print->GetMsdata()<< " mensajes"<< std::endl;
    std::cout << "Mensajes en espera: "<< print->Get_Num_Pack_wait_to_send()<<" PHE en espera "<< print->Get_Num_PHE_wait() <<std::endl;
    std::cout << "Received auv: " << print->GetMrauv() <<" send auv: " << print->GetMsauv()<< " mensajes"<< std::endl;
    std::cout << "Submarine: "<< std::endl;
    std::cout << "    Reci. solicitud: " << print->GetMrsolicitud() << " send solicitud: " << print->GetMssolicitud()<< std::endl;
    std::cout << "    Reci. sink: "<< print->GetMrsink()<<" send sink: "<<print->GetMssink() << std::endl;
    std::cout << "    Reci. ack: "<< print->GetMrack()<< " send ack: "<<print->GetMsack()<<std::endl;
    std::cout << "Caracteristicas: GW " << print->GetGW_ID() << " jumps: "<< print->GetJumps()<<" seq: "<< print->GetSeq()<< std::endl;
    std::cout << "Nodo activo: " << print->GetActivo()<< " Tipo: "<< print->GetTipe()<< std::endl;
    
    std::cout <<"mensajes creados "<<print->GetMCreate_Data()<< std::endl;
    Ptr<EnergySource> src1 = nc1.Get(i)->GetObject<EnergySourceContainer> ()->Get (0);
    
         /*std::cout << "MI adfgdsfg " << std::endl;
         inicio= src1->GetInitialEnergy ();
         fin= src1->GetRemainingEnergy ();*/
    std::cout << "Node energy consumption: " << src1->GetInitialEnergy () - src1->GetRemainingEnergy () << " J" << std::endl;
    std::cout << "----------------------------------------------------"<< std::endl;
    
    switch (print->GetTipe()){
      case 1:
        M_recividos=M_recividos+print->GetMrdata();
        break;
      case 2:
        m_recividos_auv=m_recividos_auv+print->GetMrdata();
        break;
      case 3:
        m_recividos_gw=m_recividos_gw+print->GetMrdata();
        break;
      case 4:
        m_creados_total=m_creados_total+print->GetMCreate_Data();
        energia_consumida_total=energia_consumida_total+(src1->GetInitialEnergy () - src1->GetRemainingEnergy ());
        if(print->GetID()==print->GetGW_ID())
          no_GW=no_GW+1;
        break;
      default:
        std::cout << "NODO SIN IDENTIFICAR &&&&&&&&&&"<< std::endl;
      }
     
  }
      std::cout << "***************************************************************"<< std::endl;
 /* Ptr<EnergySource> src2 = m_auv->GetObject<EnergySourceContainer> ()->Get (1);
  double init0 = src2->GetInitialEnergy ();
  double init1 = src2->GetRemainingEnergy ();
  std::cout << "AUV energy consumption (comms) : " << init0 - init1 << " J" << std::endl;

  Ptr<EnergySource> src3 = m_auv->GetObject<EnergySourceContainer> ()->Get (0);
  std::cout << "AUV energy consumption (nav): " << src3->GetInitialEnergy () - src3->GetRemainingEnergy () << " J" << std::endl;
  */



}


///obtencion de la elipse para la auv
void 
UanEnergyAuv::Elipse_auv (Ptr<WaypointMobilityModel> mob, double a, double b, double angu_despla, double x_central, double y_central){
  double angulo = 0;
  double x_ini=a, y_ini=0;
  int iteraciones=10, n=0;
  double ran_menor =0, ran_mayor=M_PI/2;
  tiempo=0;

  distancia_referencia =velocidad;
  ansx=x_ini;
  ansy=y_ini;
  while(angulo<2*M_PI*vueltas){
    angulo=ran_menor+((ran_mayor-ran_menor)/2);
	  while(n<iteraciones){
		  //Calculo de el punto x e y con el angulo estimado
		  x_aux=a*cos(angulo);
		  y_aux=b*sin(angulo);
		  x_eli=x_aux*cos(angu_despla)-y_aux*sin(angu_despla);
		  y_eli=x_aux*sin(angu_despla)+y_aux*cos(angu_despla);
	
		  //calculo de la distancia entre el punto anterior y el calculado
		  //para comparar y la velocidad sea la adecuada
		  //la distancia sea la acordada. 
		  dif_x= x_eli-ansx;
		  dif_y= y_eli-ansy;
		  dif_x = dif_x*dif_x;
		  dif_y = dif_y*dif_y;
		  distancia=sqrt( dif_x + dif_y);

		  //comprobacion de la distancia para modificar el angulo
		  if(distancia >distancia_referencia){
			  ran_mayor = angulo;
			  angulo=	ran_menor+((ran_mayor-ran_menor)/2);	
		  }else{
			  ran_menor = angulo;
			  angulo=	ran_menor+((ran_mayor-ran_menor)/2);
		  }
	  n++;
	  }

	  //inizialización de variables para la busqueda anterior
	  ansx=x_eli;
	  ansy=y_eli;
	  ran_menor=angulo;
	  ran_mayor=angulo + (M_PI/2);


	  tiempo=tiempo+frecuencia;
	  n=0;

    //std::cout << x_eli  << " "<< y_eli << " tiempo: "<< tiempo << std::endl;
	  mob->AddWaypoint (Waypoint (Seconds (tiempo), Vector (x_eli+x_central,y_eli+y_central,-2000)));
			
	
  }
  tiempo=tiempo;
}

///////modificación
  static void
TracePos (Gnuplot3dDataset* ds, Ptr<WaypointMobilityModel> mob)
{
  Vector curPos = mob->GetPosition ();
  //ds->Add (curPos.x, curPos.y, curPos.z);
  
/**/  file_mov_auv  << curPos.x << " "<< curPos.y<<  std::endl;
  Simulator::Schedule (Seconds (1),
                       &TracePos,
                       ds,
                       mob);
}



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



//crear los nodos que seran sumideros
void
UanEnergyAuv::crear_Sink(Ptr<UanChannel> channel0, Ptr<UanChannel> channel1)
{
  nc_sink.Create (nu_sink);
  //Create the underwater communication stack
  UanHelper uan;
  
  
  //capa fisica
  std::string perModel = "ns3::UanPhyPerGenDefault";
  std::string sinrModel = "ns3::UanPhyCalcSinrDefault";

  ObjectFactory obf;
  obf.SetTypeId (perModel);
  Ptr<UanPhyPer> per = obf.Create<UanPhyPer> ();
  obf.SetTypeId (sinrModel);
  Ptr<UanPhyCalcSinr> sinr = obf.Create<UanPhyCalcSinr> ();

  
  uint32_t m_dataRate = datarate;
  UanTxMode mode;
  mode = UanTxModeFactory::CreateMode (UanTxMode::FSK, m_dataRate,
      m_dataRate, 85000,
      1000, 2,
      "Default mode");
  UanModesList myModes;
  myModes.AppendMode (mode);

  uan.SetPhy ("ns3::UanPhyGen",
      "PerModel", PointerValue (per),
      "SinrModel", PointerValue (sinr),
      "SupportedModes", UanModesListValue (myModes),
      "TxPower", DoubleValue(power_py));

/*  // create a default underwater channel
  //Ptr<UanChannel> channel = CreateObject<UanChannel> ();
  Ptr<UanPropModelThorp> prop = CreateObjectWithAttributes<UanPropModelThorp> ();
	Ptr<UanChannel> channel = CreateObjectWithAttributes<UanChannel> ("PropagationModel", PointerValue (prop));
*/

/*    // create a default underwater channel
  Ptr<UanChannel> channel = CreateObject<UanChannel> ();
  Ptr<UanNoiseModelDefault> noise = CreateObject<UanNoiseModelDefault> (); //ruido
  channel->SetPropagationModel (CreateObject<UanPropModelIdeal> ());
  channel->SetNoiseModel (noise);
 */ 
  
/*  //instalacion del medio
  NetDeviceContainer devices = uan.Install (nc_sink, channel);
  
  //traza de lo ocurrido en el medio
  std::ofstream trace (m_traceFile.c_str ());
  uan.EnableAscii (trace, devices);
*/
  Ptr<AURPNode> aurp;
  Ptr<AURPNode> aux;

  for (int i=1; i<=nu_sink;i++){
    m_sink = nc_sink.Get (i-1);
    
    aurp = CreateObject<AURPNode> ();
   // aurp->SetNetDevice(devices.Get (i));
    aurp->SetID(i);
    aurp->SetGW_ID(nu_sink+1);
    aurp->SetTipe(1);
    //aurp->SetActivo(true);
    m_sink->AggregateObject(aurp);


    // install the underwater communication stack
    Ptr<UanNetDevice> devNode0 = uan.Install (m_sink, channel0);
    Ptr<UanNetDevice> devNode1 = uan.Install (m_sink, channel1);

    // energy source
    BasicEnergySourceHelper eh;
    eh.Set ("BasicEnergySourceInitialEnergyJ", DoubleValue (10000000.0));
    eh.Install (nc_sink);

    // mobility model
    Ptr<ConstantPositionMobilityModel> mobility = CreateObject<ConstantPositionMobilityModel> ();

    //calculo de la posición del gateway
    x=x_sink;
    y=y_sink;
    
    mobility->SetPosition (Vector (x,y,-2000));
    m_sink->AggregateObject (mobility);    //especifica la posición de los gateway
    
  
//MOD traza
    //Vector gatPos =mobility->GetPosition (); //optención de la posición

    Vector gatPos=m_sink->GetObject<ConstantPositionMobilityModel> ()->GetPosition();
    file_pos_nodos  <<gatPos.x << " " << gatPos.y  <<std::endl;
    file_mov_auv  <<gatPos.x << " " << gatPos.y  <<std::endl;
  

    // micro modem energy model
    /*
    Ptr<AcousticModemEnergyModel> umem = CreateObject<AcousticModemEnergyModel> ();
    Ptr<EnergySource> source = m_sink->GetObject<EnergySourceContainer> ()->Get (0);
    NS_ASSERT (source != 0);
    umem->SetEnergySource (source);
    source->AppendDeviceEnergyModel (umem);
    */
    AcousticModemEnergyModelHelper modemHelper0;
    Ptr<EnergySource> source = m_sink->GetObject<EnergySourceContainer> ()->Get (0);
    DeviceEnergyModelContainer cont0 = modemHelper0.Install (devNode0, source);
    
    AcousticModemEnergyModelHelper modemHelper1;
    DeviceEnergyModelContainer cont1 = modemHelper1.Install (devNode1, source);
    
/*    aux=m_sink->GetObject<AURPNode> ();
    Ptr<NetDevice> dev = aux->GetNetDevice();  //remite las capa de red de ese nodo
    DeviceEnergyModelContainer cont = modemHelper.Install (dev, source);
*/
    // set the receive callback

    Ptr<NetDevice> dev0 = m_sink->GetDevice (0);  //remite las capa de red de ese nodo
    dev0->SetReceiveCallback (MakeCallback (&UanEnergyAuv::RxPacket,
                                            this));  //llama a la función cuando se reciba un paquete
    
    Ptr<NetDevice> dev1 = m_sink->GetDevice (1);  //remite las capa de red de ese nodo
    dev1->SetReceiveCallback (MakeCallback (&UanEnergyAuv::RxPacket_submarino,
                                            this));  //llama a la función cuando se reciba un paquete
    
    
    Config::Set("/nc_sink/0/DeviceList/0/$ns3::PointToPointNetDevice/DataRate", StringValue("300Gbps") );
    Config::Set("/nc_sink/0/DeviceList/1/$ns3::PointToPointNetDevice/DataRate", StringValue("300Gbps") );
    
    //Config::Set("/NodeList/2/DeviceList/2/$ns3::PointToPointNetDevice/DataRate", StringValue("3Mbps") );
    //if(m_sink->GetObject<AURPNode> ()->GetID()==0)
    Simulator::Schedule (Seconds(rand()%random_wait_inicio_envios),&UanEnergyAuv::Send_PHE, this, m_sink,time_PHE_sink );
    //Programar inicio de envios de mensaje PHE con cierta aleatoriedad
    
    //almacenar el sumidero
     nc_sink.Get (i-1)=m_sink;
   //pruebas
     //std::cout << "MI identificador " << m_sink->GetObject<AURPNode> ()->GetID()  << std::endl;
  }
  //Mod traza envio mensajes GW
  //std::ofstream envios_GW ("auv/envios_GW.txt");
  uan.EnableAscii (envios_sink, nc_sink);
  
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


//crear los nodos que seran AUV
void
UanEnergyAuv::crear_AUV(Ptr<UanChannel> channel0, Ptr<UanChannel> channel1)
{
  nc_AUV.Create (nu_auv);
  //Create the underwater communication stack
  UanHelper uan;
  
  
  //capa fisica
  std::string perModel = "ns3::UanPhyPerGenDefault";
  std::string sinrModel = "ns3::UanPhyCalcSinrDefault";

  ObjectFactory obf;
  obf.SetTypeId (perModel);
  Ptr<UanPhyPer> per = obf.Create<UanPhyPer> ();
  obf.SetTypeId (sinrModel);
  Ptr<UanPhyCalcSinr> sinr = obf.Create<UanPhyCalcSinr> ();

  
  uint32_t m_dataRate = datarate;
  UanTxMode mode;
  mode = UanTxModeFactory::CreateMode (UanTxMode::FSK, m_dataRate,
      m_dataRate, 85000,
      1000, 2,
      "Default mode");
  UanModesList myModes;
  myModes.AppendMode (mode);

  uan.SetPhy ("ns3::UanPhyGen",
      "PerModel", PointerValue (per),
      "SinrModel", PointerValue (sinr),
      "SupportedModes", UanModesListValue (myModes),
      "TxPower", DoubleValue(power_py));

/*  // create a default underwater channel
  //Ptr<UanChannel> channel = CreateObject<UanChannel> ();
  Ptr<UanPropModelThorp> prop = CreateObjectWithAttributes<UanPropModelThorp> ();
	Ptr<UanChannel> channel = CreateObjectWithAttributes<UanChannel> ("PropagationModel", PointerValue (prop));
*/

/*    // create a default underwater channel
  Ptr<UanChannel> channel = CreateObject<UanChannel> ();
  Ptr<UanNoiseModelDefault> noise = CreateObject<UanNoiseModelDefault> (); //ruido
  channel->SetPropagationModel (CreateObject<UanPropModelIdeal> ());
  channel->SetNoiseModel (noise);
 */ 
  
/*  //instalacion del medio
  NetDeviceContainer devices = uan.Install (nc_AUV, channel);
  
  //traza de lo ocurrido en el medio
  std::ofstream trace (m_traceFile.c_str ());
  uan.EnableAscii (trace, devices);
*/
   // install the glider components
  //AuvGliderHelper gh;
  
  
  Ptr<AURPNode> aurp;
  Ptr<AURPNode> aux;

  for (int i=1; i<=nu_auv;i++){
    m_AUV = nc_AUV.Get (i-1);
    //gh.Install (m_auv);
    aurp = CreateObject<AURPNode> ();
   // aurp->SetNetDevice(devices.Get (i));
    aurp->SetID(nu_sink+i);
    aurp->SetGW_ID(nu_sink+i);
    aurp->SetTipe(2);
    //aurp->SetActivo(true);
    m_AUV->AggregateObject(aurp);


    // install the underwater communication stack
    Ptr<UanNetDevice> devNode0 = uan.Install (m_AUV, channel0);
    Ptr<UanNetDevice> devNode1 = uan.Install (m_AUV, channel1);

    // energy source
    BasicEnergySourceHelper eh;
    eh.Set ("BasicEnergySourceInitialEnergyJ", DoubleValue (10000000.0));
    eh.Install (nc_AUV);

    
      
      // move the vehicle somewhere
      //inicializa un objeto de  waypoint-mobility-model
      Ptr<WaypointMobilityModel> mob = CreateObject<WaypointMobilityModel> (); 
      double X_aux=A*cos(0);
		  double Y_aux=B*sin(0);
		  
		  switch (i){
      case 1:
        x= X_central1; y= Y_central1; angulo= angu_elipse1;
        break;
      case 2:
        x= X_central2; y= Y_central2;angulo= angu_elipse2;
        break;
      case 3:
        x= X_central3; y= Y_central3; angulo= angu_elipse3;
        break;
      case 4:
        x= X_central4; y= Y_central4; angulo= angu_elipse4;
        break;
      default:
        x= 0; y= 0; angulo= 0;
      }
      
      mob->AddWaypoint (Waypoint (Seconds (0), Vector ((X_aux*cos(angulo)-Y_aux*sin(angulo))+x,
                                              (X_aux*sin(angulo)+Y_aux*cos(angulo))+y,-2000)));  
      //crea e inserta el el punto inicil del movimiento de la AUV
//y_eli=x_aux*sin(angu_despla)+y_aux*cos(angu_despla);

      ////modificaciones
      Gnuplot3dDataset ds ("Navigation Trace 2");
      TracePos (&ds, mob);  

      ///obtencion de la elipse
      Elipse_auv (mob, A, B, angulo,x,y);
      m_AUV->AggregateObject (mob);
    
  

    // micro modem energy model
    /*
    Ptr<AcousticModemEnergyModel> umem = CreateObject<AcousticModemEnergyModel> ();
    Ptr<EnergySource> source = m_AUV->GetObject<EnergySourceContainer> ()->Get (0);
    NS_ASSERT (source != 0);
    umem->SetEnergySource (source);
    source->AppendDeviceEnergyModel (umem);
    */
    AcousticModemEnergyModelHelper modemHelper0;
    Ptr<EnergySource> source = m_AUV->GetObject<EnergySourceContainer> ()->Get (0);
    DeviceEnergyModelContainer cont0 = modemHelper0.Install (devNode0, source);
    
    AcousticModemEnergyModelHelper modemHelper1;
    DeviceEnergyModelContainer cont1 = modemHelper1.Install (devNode1, source);
    
/*    aux=m_AUV->GetObject<AURPNode> ();
    Ptr<NetDevice> dev = aux->GetNetDevice();  //remite las capa de red de ese nodo
    DeviceEnergyModelContainer cont = modemHelper.Install (dev, source);
*/
    // set the receive callback

    Ptr<NetDevice> dev0 = m_AUV->GetDevice (0);  //remite las capa de red de ese nodo
    dev0->SetReceiveCallback (MakeCallback (&UanEnergyAuv::RxPacket,
                                            this));  //llama a la función cuando se reciba un paquete
    
    Ptr<NetDevice> dev1 = m_AUV->GetDevice (1);  //remite las capa de red de ese nodo
    dev1->SetReceiveCallback (MakeCallback (&UanEnergyAuv::RxPacket_submarino,
                                            this));  //llama a la función cuando se reciba un paquete
    
    //if(m_AUV->GetObject<AURPNode> ()->GetID()==1)
    Simulator::Schedule (Seconds(rand()%random_wait_inicio_envios),&UanEnergyAuv::Send_AUV_prox, this, m_AUV);
    
    
    //almacenar el sumidero
     nc_AUV.Get (i-1)=m_AUV;
   //pruebas
     //std::cout << "MI identificador " << m_AUV->GetObject<AURPNode> ()->GetID()  << std::endl;
  }
  //Mod traza envio mensajes GW
  //std::ofstream envios_GW ("auv/envios_GW.txt");
  uan.EnableAscii (envios_auv, nc_AUV);
  
}


//////////////////////////////////////////////////////////////////////////////////////////////////////


//crea los nodos que serán puertas de enlace
void
UanEnergyAuv::crear_GW(Ptr<UanChannel> channel0, Ptr<UanChannel> channel1)
{
  //NodeContainer nc_GW= NodeContainer ();
  nc_GW.Create (nu_gata);
  //Create the underwater communication stack
  UanHelper uan;
  
  //capa fisica
  std::string perModel = "ns3::UanPhyPerGenDefault";
  std::string sinrModel = "ns3::UanPhyCalcSinrDefault";

  ObjectFactory obf;
  obf.SetTypeId (perModel);
  Ptr<UanPhyPer> per = obf.Create<UanPhyPer> ();
  obf.SetTypeId (sinrModel);
  Ptr<UanPhyCalcSinr> sinr = obf.Create<UanPhyCalcSinr> ();

  
  uint32_t m_dataRate = datarate;
  UanTxMode mode;
  mode = UanTxModeFactory::CreateMode (UanTxMode::FSK, m_dataRate,
      m_dataRate, 85000,
      1000, 2,
      "Default mode");
  UanModesList myModes;
  myModes.AppendMode (mode);

  uan.SetPhy ("ns3::UanPhyGen",
      "PerModel", PointerValue (per),
      "SinrModel", PointerValue (sinr),
      "SupportedModes", UanModesListValue (myModes),
      "TxPower", DoubleValue(power_py));

/*  // create a default underwater channel
  //Ptr<UanChannel> channel = CreateObject<UanChannel> ();
  Ptr<UanPropModelThorp> prop = CreateObjectWithAttributes<UanPropModelThorp> ();
	Ptr<UanChannel> channel = CreateObjectWithAttributes<UanChannel> ("PropagationModel", PointerValue (prop));
*/
  
  
/*  //instalacion del medio
  NetDeviceContainer devices = uan.Install (nc_GW, channel);
  
  //traza de lo ocurrido en el medio
  std::ofstream trace (m_traceFile.c_str ());
  uan.EnableAscii (trace, devices);
*/
  Ptr<AURPNode> aurp;
  Ptr<AURPNode> aux;

  for (int i=1; i<=nu_gata;i++){
    m_gateway = nc_GW.Get (i-1);
    
    aurp = CreateObject<AURPNode> ();
   // aurp->SetNetDevice(devices.Get (i));
    aurp->SetID(nu_sink+nu_auv+i);
    aurp->SetGW_ID(nu_sink+1);
    aurp->SetTipe(3);
    //aurp->SetActivo(true);
    m_gateway->AggregateObject(aurp);


    // install the underwater communication stack
    Ptr<UanNetDevice> devNode0 = uan.Install (m_gateway, channel0);
    Ptr<UanNetDevice> devNode1 = uan.Install (m_gateway, channel1);

    // energy source
    BasicEnergySourceHelper eh;
    eh.Set ("BasicEnergySourceInitialEnergyJ", DoubleValue (10000000.0));
    eh.Install (nc_GW);

    // mobility model
    Ptr<ConstantPositionMobilityModel> mobility = CreateObject<ConstantPositionMobilityModel> ();

    //calculo de la posición del gateway
    switch (i){
    case 1:
      x= X_GW1; y= Y_GW1;
      break;
    case 2:
      x= X_GW2; y= Y_GW2;
      break;
    case 3:
      x= X_GW3; y= Y_GW3;
      break;
    case 4:
      x= X_GW4; y= Y_GW4;
      break;
    case 5:
      x= X_GW5; y= Y_GW5;
      break;
    case 6:
      x= X_GW6; y= Y_GW6;
      break;
    case 7:
      x= X_GW7; y= Y_GW7;
      break;
    case 8:
      x= X_GW8; y= Y_GW8;
      break;
    case 9:
      x= X_GW9; y= Y_GW9;
      break;
    default:
      x=0; y=0;
    }

    mobility->SetPosition (Vector (x,y,-2000));
    m_gateway->AggregateObject (mobility);    //especifica la posición de los gateway
    
  
//MOD traza
    //Vector gatPos =mobility->GetPosition (); //optención de la posición

    Vector gatPos=m_gateway->GetObject<ConstantPositionMobilityModel> ()->GetPosition();
    file_pos_nodos  <<gatPos.x << " " << gatPos.y  <<std::endl;
    file_mov_auv  <<gatPos.x << " " << gatPos.y  <<std::endl;
  

    // micro modem energy model
    /*
    Ptr<AcousticModemEnergyModel> umem = CreateObject<AcousticModemEnergyModel> ();
    Ptr<EnergySource> source = m_gateway->GetObject<EnergySourceContainer> ()->Get (0);
    NS_ASSERT (source != 0);
    umem->SetEnergySource (source);
    source->AppendDeviceEnergyModel (umem);
    */
    
    AcousticModemEnergyModelHelper modemHelper0;
    Ptr<EnergySource> source = m_gateway->GetObject<EnergySourceContainer> ()->Get (0);
    DeviceEnergyModelContainer cont0 = modemHelper0.Install (devNode0, source);
    
    AcousticModemEnergyModelHelper modemHelper1;
    DeviceEnergyModelContainer cont1 = modemHelper1.Install (devNode1, source);
    
/*    aux=m_gateway->GetObject<AURPNode> ();
    Ptr<NetDevice> dev = aux->GetNetDevice();  //remite las capa de red de ese nodo
    DeviceEnergyModelContainer cont = modemHelper.Install (dev, source);
    
    
*/

    //Config::Set("/NodeList/0/DeviceList/0/$ns3::PointToPointNetDevice/DataRate", StringValue("30000Gbps") );
    //Config::Set("/nc_sink/0/DeviceList/1/$ns3::PointToPointNetDevice/DataRate", StringValue("300Gbps") );
    //Config::Set("/NodeList/1/DeviceList/0/$ns3::PointToPointNetDevice/DataRate", StringValue("300Gbps") );
    //Config::Set("/nc_sink/1/DeviceList/1/$ns3::PointToPointNetDevice/DataRate", StringValue("300Gbps") );
    
    // set the receive callback

    Ptr<NetDevice> dev0 = m_gateway->GetDevice (0);  //remite las capa de red de ese nodo
    dev0->SetReceiveCallback (MakeCallback (&UanEnergyAuv::RxPacket,
                                            this));  //llama a la función cuando se reciba un paquete
    Ptr<NetDevice> dev1 = m_gateway->GetDevice (1);  //remite las capa de red de ese nodo
    dev1->SetReceiveCallback (MakeCallback (&UanEnergyAuv::RxPacket_submarino,
                                            this));  //llama a la función cuando se reciba un paquete
    
    
    
    
    //Simulator::ScheduleNow (&UanEnergyAuv::SendOnePacket,this,m_gateway);
    //if(m_gateway->GetObject<AURPNode> ()->GetID()==2)
    Simulator::Schedule (Seconds(rand()%random_wait_inicio_envios),&UanEnergyAuv::Send_PHE, this, m_gateway, time_PHE_GW);
    //Simulator::ScheduleNow (&UanEnergyAuv::Send_Data, this, m_gateway);
    //Simulator::ScheduleNow (&UanEnergyAuv::Send_submarino, this, m_gateway);
    //Simulator::ScheduleNow (&UanEnergyAuv::Crear_data, this, m_gateway);
    
    //almacenar el GW
     nc_GW.Get (i-1)=m_gateway;
   //pruebas
     //std::cout << "MI identificador " << m_gateway->GetObject<AURPNode> ()->GetID()  << std::endl;
  }
  //Mod traza envio mensajes GW
  //std::ofstream envios_GW ("auv/envios_GW.txt");
  uan.EnableAscii (envios_GW, nc_GW);
  
}



/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



void
UanEnergyAuv::crear_Sensor(Ptr<UanChannel> channel0)
{
  //NodeContainer nc_sensors= NodeContainer ();
  nc_sensors.Create (nu_sensor);
  //Create the underwater communication stack
  UanHelper uan;
  
  //capa fisica
  std::string perModel = "ns3::UanPhyPerGenDefault";
  std::string sinrModel = "ns3::UanPhyCalcSinrDefault";

  ObjectFactory obf;
  obf.SetTypeId (perModel);
  Ptr<UanPhyPer> per = obf.Create<UanPhyPer> ();
  obf.SetTypeId (sinrModel);
  Ptr<UanPhyCalcSinr> sinr = obf.Create<UanPhyCalcSinr> ();

  
  uint32_t m_dataRate = datarate;
  UanTxMode mode;
  mode = UanTxModeFactory::CreateMode (UanTxMode::FSK, m_dataRate,
      m_dataRate, 85000,
      1000, 2,
      "Default mode");
  UanModesList myModes;
  myModes.AppendMode (mode);

  uan.SetPhy ("ns3::UanPhyGen",
      "PerModel", PointerValue (per),
      "SinrModel", PointerValue (sinr),
      "SupportedModes", UanModesListValue (myModes),
      "TxPower", DoubleValue(power_py));


    /*PointToPointHelper pointToPoint;
    pointToPoint.SetDeviceAttribute ("DataRate", StringValue ("300Gbps"));
    //pointToPoint.SetChannelAttribute ("Delay", StringValue ("2ms"));
    NetDeviceContainer devices00 = pointToPoint.Install (nc_sensors);*/
/*  // create a default underwater channel
  //Ptr<UanChannel> channel = CreateObject<UanChannel> ();
  Ptr<UanPropModelThorp> prop = CreateObjectWithAttributes<UanPropModelThorp> ();
	Ptr<UanChannel> channel = CreateObjectWithAttributes<UanChannel> ("PropagationModel", PointerValue (prop));
*/
  
  
/*  //instalacion del medio
  NetDeviceContainer devices = uan.Install (nc_sensors, channel);
  
  //traza de lo ocurrido en el medio
  std::ofstream trace (m_traceFile.c_str ());
  uan.EnableAscii (trace, devices);
*/
  Ptr<AURPNode> aurp;
  Ptr<AURPNode> aux;

  for (int i=0; i<nu_sensor;i++){
    m_sensor = nc_sensors.Get (i);
    
    aurp = CreateObject<AURPNode> ();
   // aurp->SetNetDevice(devices.Get (i));
    aurp->SetID(nu_sink + nu_auv + nu_gata + i +1);
    //aurp->SetGW_ID(aurp->GetID());
    aurp->SetGW_ID(1);
    aurp->SetJumps(65534);        //cerca del maximo posible con ese tipo de datos
    aurp->SetGW_ID(aurp->GetID());
    //aurp->SetGW_ID(3);
    aurp->SetTipe(4);
    aurp->SetTime_PHE(Time_PHE_procesar);
    //aurp->SetActivo(true);
    m_sensor->AggregateObject(aurp);


    // install the underwater communication stack
    Ptr<UanNetDevice> devNode1 = uan.Install (m_sensor, channel0);
    

    // energy source
    BasicEnergySourceHelper eh;
    eh.Set ("BasicEnergySourceInitialEnergyJ", DoubleValue (10000000.0));
    eh.Install (nc_sensors);

    // mobility model
    Ptr<ConstantPositionMobilityModel> mobility = CreateObject<ConstantPositionMobilityModel> ();

    //calculo de la posición del gateway
    y=rand() % y_map;
    x=rand() % x_map;
    //x=0;y=50+50*i;

    mobility->SetPosition (Vector (x,y,-2000));
    m_sensor->AggregateObject (mobility);    //especifica la posición de los gateway
    
  
//MOD traza
    //Vector gatPos =mobility->GetPosition (); //optención de la posición

    Vector gatPos=m_sensor->GetObject<ConstantPositionMobilityModel> ()->GetPosition();
    file_pos_nodos  <<gatPos.x << " " << gatPos.y  <<std::endl;
    file_mov_auv  <<gatPos.x << " " << gatPos.y  <<std::endl;
  

    // micro modem energy model
    /*
    Ptr<AcousticModemEnergyModel> umem = CreateObject<AcousticModemEnergyModel> ();
    Ptr<EnergySource> source = m_sensor->GetObject<EnergySourceContainer> ()->Get (0);
    NS_ASSERT (source != 0);
    umem->SetEnergySource (source);
    source->AppendDeviceEnergyModel (umem);
    */
    AcousticModemEnergyModelHelper modemHelper;
    Ptr<EnergySource> source = m_sensor->GetObject<EnergySourceContainer> ()->Get (0);
    DeviceEnergyModelContainer cont = modemHelper.Install (devNode1, source);
    
/*    aux=m_sensor->GetObject<AURPNode> ();
    Ptr<NetDevice> dev = aux->GetNetDevice();  //remite las capa de red de ese nodo
    DeviceEnergyModelContainer cont = modemHelper.Install (dev, source);
*/
    // set the receive callback

    Ptr<NetDevice> dev = m_sensor->GetDevice (0);  //remite las capa de red de ese nodo
    dev->SetReceiveCallback (MakeCallback (&UanEnergyAuv::RxPacket,
                                            this));  //llama a la función cuando se reciba un paquete
    
    //Config::Set("/NodeList/1/DeviceList/0/$ns3::PointToPointNetDevice/DataRate", StringValue("300Gbps") );
    //Config::Set("/NodeList/1/DeviceList/0/$ns3::UanNetDevice/Channel/DataRate", StringValue("300Gbps") ); 
    //Simulator::ScheduleNow (&UanEnergyAuv::SendOnePacket,this,m_sensor);
    //(m_sensor->GetObject<AURPNode> ()->GetID()==1)
    //Simulator::ScheduleNow (&UanEnergyAuv::Send_PHE, this, m_sensor);
    //Ptr<DataRate> rate= CreateObject<DataRate> ();
    //else
    //Ptr<PointToPointNetDevice> net= dev->GetObject<UanNetDevice> ()->GetObject<PointToPointNetDevice>();
    //Ptr<DataRate> rate=ns3::DataRate("300b/s");
    //ptr<DataRate> rate =net->GetObject<DataRate>();
    //net->SetDataRate(DataRate("30Gbps"));
    
    //Config::Set("/NodeList/1/DeviceList/0/$ns3::UanNetDevice/$ns3::PointToPointNetDevice/DataRate", StringValue("300Gbps") );
      
    
    
    
    //if(i==0)
    Simulator::Schedule (Seconds(rand()%random_wait_inicio_envios),&UanEnergyAuv::Send_Data, this, m_sensor);
    
    
    //almacenar el GW
     nc_sensors.Get (i)=m_sensor;
   //pruebas
     //std::cout << "MI identificador " << m_sensor->GetObject<AURPNode> ()->GetID()  << std::endl;
  }
  /*if(nu_sensor>0)
  NetDeviceContainer devices00 = pointToPoint.Install (nc_sensors);*/
  //Mod traza envio mensajes GW
  //std::ofstream envios_GW ("auv/envios_GW.txt");
  uan.EnableAscii (envios_sensor, nc_sensors);
  
}


bool
UanEnergyAuv::Run ()
{
/////////////////////////////////////////////////////////////////////////////////
  // create a gateway node
//Mod mas gat 
  file_pos_nodos.open(nom_pos_nodos.c_str());
  file_mov_auv.open(nom_pos_auv.c_str());
  
  envios_sink.open(nom_envios_sink.c_str()); 
  envios_auv.open(nom_envios_auv.c_str());
  envios_GW.open(nom_envios_GW.c_str()); 
  envios_sensor.open(nom_envios_sensor.c_str());
  
  
  // create a default underwater channel
  Ptr<UanChannel> channel0 = CreateObject<UanChannel> ();
  Ptr<UanNoiseModelDefault> noise = CreateObject<UanNoiseModelDefault> (); //ruido
  channel0->SetPropagationModel (CreateObject<UanPropModelThorp> ());       //Metodo de propagación del sonidoThorp
  //channel0->SetPropagationModel (CreateObject<UanPropModelIdeal> ()); 
  channel0->SetNoiseModel (noise);
  
  //canal para las comunicacines "privadas" con el submarino
  Ptr<UanChannel> channel1 = CreateObject<UanChannel> ();
  Ptr<UanNoiseModelDefault> noise1 = CreateObject<UanNoiseModelDefault> (); //ruido
  //channel1->SetPropagationModel (CreateObject<UanPropModelIdeal> ());       //Metodo de propagación del sonido ideal
  channel1->SetPropagationModel (CreateObject<UanPropModelThorp> ());       //Metodo de propagación del sonidoThorp
  channel1->SetNoiseModel (noise1);
  //channel1->set

  crear_Sink(channel0,channel1);
  crear_AUV(channel0,channel1);
  crear_GW(channel0,channel1);
  crear_Sensor(channel0);
  
  // run the simulation
  Simulator::Stop (Seconds (tiempo));
  std::cout << "El tiempo de la simulación sera en segundos:  "<<tiempo  << std::endl;
  Simulator::Run ();

  // print the simulation's statistics
  PrintStats (nc_sink);
  PrintStats (nc_AUV);
  PrintStats (nc_GW);
  PrintStats (nc_sensors);
  

  Simulator::Destroy ();
  
  std::cout << "----------------------------------simulador fin----------"<< std::endl;
  envios_sink.close();
  envios_GW.close();
  envios_sensor.close();
  envios_auv.close();

  return false;
}

int
main (int argc, char *argv[])
{
  // uncomment to see models log
  // LogComponentEnable("GliderEnergyModel", LOG_LEVEL_ALL);
  // LogComponentEnable("BasicEnergySource", LOG_LEVEL_ALL);
  // LogComponentEnable("LiIonEn ergySource", LOG_LEVEL_ALL);
  // LogComponentEnable("AcousticModemEnergyModel", LOG_LEVEL_ALL);
  //LogComponentEnable("UanChannel", LOG_LEVEL_ALL);
  LogComponentEnable("PointToPointNetDevice",  LOG_LEVEL_ALL);
  //Gnuplot3dDataset ds ("Navigation Trace 2"); 
  
  
  //con estas lineas de codigo seconsigue que lo que le pasas por comando lo cambie en las variables.
	CommandLine cmd;
	//cmd.Usage("no se si funcionara");
	cmd.AddValue("nu_sink", "Numero de sumideros", nu_sink);
	cmd.AddValue("x_sink", "Posicion X del sumidero", x_sink);
	cmd.AddValue("y_sink", "Posicion Y del sumidero ",y_sink );
	cmd.AddValue("nu_auv", "Numero de AUV, maximo 4 ", nu_auv );
	cmd.AddValue("A", "Tamaño de la mitad eje mayor de la  elipse ", A);
	cmd.AddValue("B", " Tamaño de la mitad eje menor de la  elipse", B );
	cmd.AddValue("angu_elipse1", "Angulo en radianes del desplazamiento de la elipse del eje x. AUV1 ", angu_elipse1 );
	cmd.AddValue("angu_elipse2", "Angulo en radianes del desplazamiento de la elipse del eje x. AUV2 ", angu_elipse2 );
	cmd.AddValue("angu_elipse3", "Angulo en radianes del desplazamiento de la elipse del eje x. AUV3 ", angu_elipse3 );
	cmd.AddValue("angu_elipse4", "Angulo en radianes del desplazamiento de la elipse del eje x. AUV4 ", angu_elipse4 );
	cmd.AddValue("vueltas", "Numero de vueltas que realizará la AUV",vueltas );
	cmd.AddValue("X_central1", "Posicion X del centro de la elipse. AUV1 ", X_central1);
	cmd.AddValue("X_central2", "Posicion X del centro de la elipse. AUV2 ", X_central2);
	cmd.AddValue("X_central3", "Posicion X del centro de la elipse. AUV3 ", X_central3);
	cmd.AddValue("X_central4", "Posicion X del centro de la elipse. AUV4 ", X_central4);
	cmd.AddValue("Y_central1", "Posicion Y del centro de la elipse. AUV1 ", Y_central1);
	cmd.AddValue("Y_central2", "Posicion Y del centro de la elipse. AUV2 ", Y_central2);
	cmd.AddValue("Y_central3", "Posicion Y del centro de la elipse. AUV3 ", Y_central3);
	cmd.AddValue("Y_central4", "Posicion Y del centro de la elipse. AUV4 ", Y_central4);
	cmd.AddValue("nu_gata", "Numero de puertas de enlace GW. Maximo 9 ", nu_gata );
  cmd.AddValue("X_GW1","Posicion del primer GW en el eje X",X_GW1);
  cmd.AddValue("X_GW2","Posicion del 2 GW en el eje X",X_GW2);
  cmd.AddValue("X_GW3","Posicion del 3 GW en el eje X",X_GW3);
  cmd.AddValue("X_GW4","Posicion del 4 GW en el eje X",X_GW4);
  cmd.AddValue("X_GW5","Posicion del 5 GW en el eje X",X_GW5);
  cmd.AddValue("X_GW6","Posicion del 6 GW en el eje X",X_GW6);
  cmd.AddValue("X_GW7","Posicion del 7 GW en el eje X",X_GW7);
  cmd.AddValue("X_GW8","Posicion del 8 GW en el eje X",X_GW8);
  cmd.AddValue("X_GW9","Posicion del 9 GW en el eje X",X_GW9);
  cmd.AddValue("Y_GW1","Posicion del 1 GW en el eje Y",Y_GW1);
  cmd.AddValue("Y_GW2","Posicion del 2 GW en el eje Y",Y_GW2);
  cmd.AddValue("Y_GW3","Posicion del 3 GW en el eje Y",Y_GW3);
  cmd.AddValue("Y_GW4","Posicion del 4 GW en el eje Y",Y_GW4);
  cmd.AddValue("Y_GW5","Posicion del 5 GW en el eje Y",Y_GW5);
  cmd.AddValue("Y_GW6","Posicion del 6 GW en el eje Y",Y_GW6);
  cmd.AddValue("Y_GW7","Posicion del 7 GW en el eje Y",Y_GW7);
  cmd.AddValue("Y_GW8","Posicion del 8 GW en el eje Y",Y_GW8);
  cmd.AddValue("Y_GW9","Posicion del 9 GW en el eje Y",Y_GW9);
	cmd.AddValue("nu_sensor", "Numero de Sensores ", nu_sensor );
	cmd.AddValue("x_map", "Tamaño del mapa en el eje x ",x_map );
	cmd.AddValue("y_map","Tamaño del mapa en el eje y ",y_map );
	cmd.AddValue("time_AUV","Tiempo entre envios de mensajes AUV de reconocimiento en segundos", time_AUV );
	cmd.AddValue("time_PHE_GW","Tiempo entre envios de mensajes PHE de reconocimiento en segundos", time_PHE_GW );
	cmd.AddValue("time_PHE_sink","Tiempo entre envios de mensajes PHE de reconocimiento en segundos", time_PHE_sink );
	cmd.AddValue("time_data","Tiempo entre generacion de mensajes de datos en segundos", time_data );
	cmd.AddValue("Time_PHE_procesar","Tiempo de espera para procesar los mensajes PHE.", Time_PHE_procesar);
	cmd.AddValue("random_wait_inicio_envios","Tienpo maximo de espera a la hora de lanzar la rutina repetitiba de envio de mensajes [0-wait]"
	              ,random_wait_inicio_envios );
	cmd.AddValue("nom_envios_sink","Nombre del fichero de traza de los sumideros", nom_envios_sink );
	cmd.AddValue("nom_envios_AUV","Nombre del fichero de traza de los submarinos", nom_envios_auv );
	cmd.AddValue("nom_envios_GW","Nombre del fichero de traza de los GW", nom_envios_GW );
	cmd.AddValue("nom_envios_sensor","Nombre del fichero de traza de los sensores", nom_envios_sensor );
  cmd.AddValue("nom_pos_nodos","nombre del archivo donde se encuentran los nodos", nom_pos_nodos );
  cmd.AddValue("nom_pos_auv","Nomre del archivo donde dice la ruta de la AUV",nom_pos_auv );
	//cmd.AddValue("","", );
	cmd.Parse (argc, argv);
  
  
  std::cout << "Parametros de la simulación"<<std::endl;
  
  std::cout <<"nu_sink= "<< nu_sink<< " , x_sink= "<< x_sink << " , y_sink= " << y_sink<<std::endl;
	std::cout <<"nu_auv= "<< nu_auv<< " ,A= "<<A<< " ,B= "<<B<< " X_central1= " <<X_central1<<" Y_central1= "<<Y_central1<<" angu_elipse1= "<<angu_elipse1
	    << " X_central2= " <<X_central2<<" Y_central2= "<<Y_central2<<" angu_elipse2= "<<angu_elipse2
	    << " X_central3= " <<X_central3<<" Y_central3= "<<Y_central3<<" angu_elipse3= "<<angu_elipse3
	    << " X_central4= " <<X_central4<<" Y_central4= "<<Y_central4<<" angu_elipse4= "<<angu_elipse4<<" vueltas= "<<vueltas<<std::endl;
	std::cout <<"nu_gata= "<<nu_gata<<" X_GW1= "<<X_GW1<<" Y_GW1= "<<Y_GW1<<" X_GW2= "<<X_GW2<<" Y_GW2= "<<Y_GW2<<" X_GW2= "
	    <<" X_GW3= "<<X_GW3<<" Y_GW3= "<<Y_GW3<<" X_GW4= "<<X_GW4<<" Y_GW4= "<<Y_GW4<<" X_GW5= "<<X_GW5<<" Y_GW5= "<<Y_GW5<<" X_GW6= "<<X_GW6<<" Y_GW6= "<<Y_GW6
	    <<" X_GW7= "<<X_GW7<<" Y_GW7= "<<Y_GW7<<" X_GW8= "<<X_GW8<<" Y_GW8= "<<Y_GW8<<" X_GW9= "<<X_GW9<<" Y_GW9= "<<Y_GW9 <<std::endl;
	std::cout <<"nu_sensor= "<<nu_sensor<<" x_map= "<<x_map<<" y_map= "<<y_map <<std::endl;
	std::cout <<"time_AUV= "<<time_AUV<<" time_data= "<<time_data<<" time_PHE_GW= "<<time_PHE_GW<<" time_PHE_sink= "<<time_PHE_sink<<std::endl;
	std::cout <<"nom_envios_sink= "<<nom_envios_sink<<" nom_envios_AUV= "<<nom_envios_auv<<" nom_envios_GW= "<<nom_envios_GW<<" nom_envios_sensor= "<<nom_envios_sensor<<std::endl;
	std::cout <<"nom_pos_nodos= "<<nom_pos_nodos<<" nom_pos_auv= "<<nom_pos_auv<<std::endl;

  UanEnergyAuv uan;
  uan.Run ();

  
  
///MOD traza
  file_pos_nodos.close();
  file_mov_auv.close();
  
  std::cout <<"Numero de mensajes creados: "<< m_creados_total<<" numero de mensajes recibidos "<< M_recividos<<std::endl;
  std::cout << "porcentaje de recepción: "<< (double)M_recividos/m_creados_total<<std::endl;
  std::cout <<" Energia consumida: "<<energia_consumida_total<< " Dividida por le nmero de sensores: "<<energia_consumida_total/nu_sensor <<std::endl;
  std::cout << "Numero de mensajes recibidos por GW: "<< m_recividos_gw<< " En porcentaje: "<< (double)m_recividos_gw/m_creados_total<<std::endl;
  std::cout << "Numero de mensajes recibidos por AUV: "<<m_recividos_auv<<" en porcentaje: "<< (double)m_recividos_auv/m_creados_total<<std::endl;
  std::cout << "Numero de nodos sin GW: "<<no_GW<<" en porcentaje: "<< (double)no_GW/nu_sensor<<std::endl;
  


/*  int random;
  int contar [20];
  for (int i=0; i<20;i++)contar[i]=0;
  for (int i=0; i<20000;i++){
    random=rand()%random_wait_inicio_envios;
    //std::cout << random<< std::endl;
    contar[random]=contar[random]+1;
  }
  for (int i=0; i<20;i++)
  std::cout << contar[i]<< std::endl;
*/


  return 0;
}
